//******************************************************************
// 	Arquivo SERIAL.C
// 	Permite o uso da USART do microcontrolador PIC
//******************************************************************
#include <stdio.h>
#include "serial.h"

//******************************************************************
// Funçao init_comms - configura a USART do PIC
//	recebe:
//		nada
//	retorna:
//		nada
//******************************************************************
void init_comms(void){
		SPBRG = DIVIDER;								//seta velocidade     	
		TXSTA = (SPEED|NINE_BITS|0x20);			//numero de bits
		RCSTA = (NINE_BITS|0x90);
		TRISC6=OUTPUT;									//TX (16F877)
		TRISC7=INPUT;									//RX (16F877)
}

//******************************************************************
// Funcao putch - envia um byte atraves da USART do PIC
//	recebe:
//		caracter a ser enviado
//	retorna:
//		nada
//******************************************************************
void putch(unsigned char byte){
		while(!TXIF)									//aguarda buffer vazio
			continue;
		TXREG = byte;									//envia caracter
}

//******************************************************************
// Funcao getch - recebe um byte atraves da USART do PIC
//	Atencao: funcao aguarda ate que um caracter seja recebido!!! 
//	recebe:
//		nada
//	retorna:
//		byte recebido
//******************************************************************
unsigned char getch(){
		while(!RCIF)									//aguarda entrada do byte
			continue;										
		return RCREG;									//retorna byte
}

//******************************************************************
// Funcao getche - recebe e envia um byte de eco atraves da USART do PIC
//	recebe:
//		caracter a ser enviado
//	retorna:
//		caracter recebido
//******************************************************************
unsigned char getche(void)
{
	unsigned char c;
	putch(c = getch());
	return c;
}

