//******************************************************************
// 	Arquivo SERIAL.H
// 	Configura USART do microcontrolador
//******************************************************************

#ifndef _SERIAL_H_
#define _SERIAL_H_

//******************************************************************
//	Definies de velocidade, nmero de bits e outros
//****************************************************************** 
#define BAUD 9600      
#define FOSC 4000000L
#define NINE 0     /* Use 9bit communication? FALSE=8bit */
#define OUTPUT 0
#define INPUT 1

//******************************************************************
//	calcula valor para registrador SPBRG e seta velocidade em HIGH
//******************************************************************
#define DIVIDER ((int)(FOSC/(16UL * BAUD) -1))
#define HIGH_SPEED 1

//******************************************************************
//	define se trabalha com 8 ou 9 bits
//******************************************************************
#if NINE == 1
#define NINE_BITS 0x40
#else
#define NINE_BITS 0
#endif

//******************************************************************
//	define velocidade: low ou high
//******************************************************************
#if HIGH_SPEED == 1
#define SPEED 0x4
#else
#define SPEED 0
#endif

//******************************************************************
//	declarao das funes do mdulo SERIAL.C
//******************************************************************
void init_comms(void);						//inicializa USART
void putch(unsigned char);				//envia um caracter (byte)
unsigned char getch(void);				//recebe um byte
unsigned char getche(void);				//recebe um byte e envia eco


#endif
